## mingw-w64-pdf2djvu-0.9.19-15.src.tar.zst

=== Makefile ===
# Copyright © 2007-2022 Jakub Wilk <jwilk@jwilk.net>
#
# This file is part of pdf2djvu.
#
# pdf2djvu is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
#
# pdf2djvu is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

srcdir = .
include $(srcdir)/autoconf.mk

exe = pdf2djvu$(EXEEXT)

.PHONY: all
all: $(exe)

ifneq "$(WINDRES)" ""
win32-version.o: win32-version.rc autoconf.hh
	$(WINDRES) -c 65001 -o $(@) $(<)
$(exe): win32-version.o
endif

include Makefile.dep

paths.hh: tools/generate-paths-hh
	$(<) $(foreach var,localedir djvulibre_bindir,$(var) $($(var)))

$(exe): config.o
$(exe): debug.o
$(exe): djvu-outline.o
$(exe): i18n.o
$(exe): image-filter.o
$(exe): main.o
$(exe): pdf-backend.o
$(exe): pdf-document-map.o
$(exe): pdf-dpi.o
$(exe): pdf-unicode.o
$(exe): sexpr.o
$(exe): string-format.o
$(exe): string-printf.o
$(exe): string-utils.o
$(exe): sys-command-posix.o
$(exe): sys-command-win32.o
$(exe): sys-encoding.o
$(exe): sys-time.o
$(exe): sys-uuid.o
$(exe): system.o
$(exe): version.o
$(exe): xmp.o
$(exe):
	$(LINK.cc) $(^) $(LDLIBS) -o $(@)

.PHONY: clean
clean:
	rm -f $(exe) *.o paths.hh
	$(MAKE) -C tests/ clean

.PHONY: distclean
distclean: clean
	rm -f autoconf.hh autoconf.mk config.status config.log

.PHONY: vcs-clean
vcs-clean:
	$(MAKE) -C tests/ vcs-clean
	$(MAKE) -C po clean
	$(MAKE) -C doc clean
	$(MAKE) -C doc/po clean
	rm -rf autoconf.hh autoconf.hh.in config.log config.status configure
	rm -rf autom4te.cache
	rm -rf aclocal.m4 m4
	rm -f tools/config.* tools/install-sh
	$(MAKE) distclean

.PHONY: test
test: $(exe)
	$(MAKE) -C tests/

.PHONY: test-installed
test-installed: $(or $(shell command -v pdf2djvu;),$(bindir)/pdf2djvu)
	$(MAKE) -C tests/ pdf2djvu=$(exe)

man_pages = $(wildcard doc/*.1 doc/po/*.1)
mo_files = $(wildcard po/*.mo)

.PHONY: install
install: all
	$(INSTALL) -d $(DESTDIR)$(bindir)
	$(INSTALL) $(exe) $(DESTDIR)$(bindir)
	INSTALL='$(INSTALL)' tools/install-manpages $(DESTDIR)$(mandir) $(man_pages)
	INSTALL='$(INSTALL)' tools/install-mo $(DESTDIR)$(localedir) $(mo_files)

.error = GNU make is required

# vim:ts=4 sts=4 sw=4 noet

=== win32/Makefile ===
# Copyright © 2009-2022 Jakub Wilk <jwilk@jwilk.net>
#
# This file is part of pdf2djvu.
#
# pdf2djvu is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
#
# pdf2djvu is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

usr = $(CURDIR)
host = i686-w64-mingw32
docbook_xsl = http://docbook.sourceforge.net/release/xsl/current/html/docbook.xsl

rst2html = $(notdir $(shell command -v rst2html || echo rst2html.py)) \
	--input-encoding=UTF-8 \
	--strict

ifeq "$(wildcard ../.git)" ""
version := $(shell IFS='()' read _ v _ < ../doc/changelog && echo $$v)
orig_src_tarball = pdf2djvu-$(version).tar.xz
else
orig_src_tarball := $(shell ../private/build-source-tarball --print-name)
version = $(word 2,$(subst .tar, ,$(subst -, ,$(orig_src_tarball))))
endif

ifeq "$(orig_src_tarball)" ""
$(error cannot determine orig source tarball name)
endif

djvulibre_tools = bzz c44 cjb2 csepdjvu djvuextract djvumake djvused djvmcvt

download =
untar = tar --strip-components=1 -xf
ship_dll = install -m 644 bin/$1*.dll dist/ && $(STRIP) dist/$1*.dll

cmake_options = \
	-DCMAKE_SYSTEM_NAME=Windows \
	-DCMAKE_INSTALL_PREFIX=$(usr) \
	-DCMAKE_FIND_ROOT_PATH=$(usr) \
	-DCMAKE_FIND_ROOT_PATH_MODE_LIBRARY=ONLY \
	-DCMAKE_FIND_ROOT_PATH_MODE_INCLUDE=ONLY \

export CC = $(host)-gcc
export CXX = $(host)-g++
export AS = $(host)-as
export DLLTOOL = $(host)-dlltool
export OBJDUMP = $(host)-objdump
export STRIP = $(host)-strip

export PKG_CONFIG_PATH = $(usr)/lib/pkgconfig
export CPATH = $(usr)/include
export LDFLAGS = -L$(usr)/lib

export CFLAGS = -Os
export CXXFLAGS = -Os -std=gnu++17

export V = 1
export VERBOSE = 1

export WINEDEBUG ?= err+all,fixme-all
export WINE = wine
export WINESERVER = /usr/lib/wine/wineserver32

ifneq "$(download)" ""
export PDF2DJVU_DOWNLOAD = 1
endif

.PHONY: all
all:
	@echo Usage:
	@echo '  make source-dist'
	@echo '  make binary-dist'

.PHONY: clean

# source tarballs

src_tarball_topdir = pdf2djvu-win32-source-$(version)
src_tarball_name = pdf2djvu-win32-source-$(version)
tar_opts = --owner root --group root --mode u=rwX,go=rX --format ustar --sort name
xz_opts = -8e

.PHONY: source-dist
source-dist:
	$(MAKE) $(shell grep '/source[-]stamp:' Makefile | cut -d: -f1)
	rm -rf $(src_tarball_topdir)
	mkdir $(src_tarball_topdir)
	cp -rl src/*/ $(src_tarball_topdir)/
	find $(src_tarball_topdir) -name source-stamp -delete
	find $(src_tarball_topdir) -type d -name .pc | xargs rm -rf
	tar $(tar_opts) -I 'xz -v $(xz_opts)' -cf $(src_tarball_name).tar.xz $(src_tarball_topdir)
	rm -rf $(src_tarball_topdir)

.PHONY: clean-source
clean: clean-source
clean-source:
	rm -rf src/
	rm -rf $(src_tarball_topdir)
	rm -f $(src_tarball_name).tar.xz

# binary zipballs

zipball_topdir = pdf2djvu-$(version)
zipball_name = pdf2djvu-win32-$(version)
zip_opts = -9 -X -r

.PHONY: binary-dist
binary-dist: install
	rm -rf $(zipball_topdir)
	mkdir $(zipball_topdir)
	! strings -f dist/*.exe dist/*.dll | grep -F '$(CURDIR)'
	! strings -l e -f dist/*.exe dist/*.dll | grep -F '$(CURDIR)'
	cp -rl dist/* $(zipball_topdir)
	chmod a-x $(zipball_topdir)/*.exe
	chmod -R u=rwX,go=rX $(zipball_topdir)
	zip $(zip_opts) $(zipball_name).zip $(zipball_topdir)
	rm -r $(zipball_topdir)

.PHONY: clean-binary
clean: clean-binary
clean-binary:
	rm -rf bin/ etc/ include/ lib/ share/
	rm -rf dist/
	rm -rf $(zipball_topdir)
	rm -f $(zipball_name).zip

.PHONY: install
install: src/pdf2djvu/install-stamp
install: src/libs-install-stamp
install: src/urw-fonts/install-stamp
install: src/poppler-data/install-stamp

# pdf2djvu

src/pdf2djvu/source-stamp: ../dist/$(orig_src_tarball)
	mkdir -p $(dir $@)
	$(untar) $(<) -C $(dir $@)
	rm -f $(dir $@)/paths.hh
	touch $(@)

src/pdf2djvu/config.status: src/pdf2djvu/source-stamp
src/pdf2djvu/config.status: src/djvulibre/install-stamp
src/pdf2djvu/config.status: src/gettext/install-stamp
src/pdf2djvu/config.status: src/graphicsmagick/install-stamp
src/pdf2djvu/config.status: src/exiv2/install-stamp
src/pdf2djvu/config.status: src/mingwrt/install-stamp
src/pdf2djvu/config.status: src/poppler/install-stamp
	cd $(dir $@) && \
		./configure --host=$(host) --prefix=$(usr) \
		--bindir=$(usr)/dist/ \
		--localedir=$(usr)/dist/locale/ \
		--with-graphicsmagick \
		--enable-xmp \
		--disable-openmp

src/pdf2djvu/build-stamp: src/pdf2djvu/config.status
	$(MAKE) djvulibre_bindir=. localedir=./locale -C $(dir $@)
	touch $(@)

src/pdf2djvu/install-stamp: src/pdf2djvu/build-stamp
	install -d dist/doc/
	$(MAKE) install -C $(dir $@)
	$(STRIP) dist/pdf2djvu.exe
	xsltproc --nonet $(docbook_xsl) src/pdf2djvu/doc/manpage.xml > dist/doc/manpage.html
	$(MAKE) -C $(dir $@)/doc/po/ xml
	cd src/pdf2djvu/doc/po/ && set -e && \
		for file in *.xml; do \
			locale="$${file%.*}"; \
			xsltproc --nonet $(docbook_xsl) $$file > $(usr)/dist/doc/manpage-$$locale.html; \
		done
	sed -e 's/$$/\r/' < src/pdf2djvu/doc/COPYING > dist/doc/COPYING.txt
	cd src/pdf2djvu/doc && \
		ls README credits djvudigital \
		| xargs -I{file} -t $(rst2html) {file} $(usr)/dist/doc/{file}.html
	sed -e 's/$$/\r/' < src/pdf2djvu/doc/changelog > dist/doc/changelog.txt
	touch $(@)

# various libraries

src/libs-install-stamp: src/djvulibre/install-stamp
src/libs-install-stamp: src/fontconfig/install-stamp
src/libs-install-stamp: src/freetype/install-stamp
src/libs-install-stamp: src/gettext/install-stamp
src/libs-install-stamp: src/graphicsmagick/install-stamp
src/libs-install-stamp: src/libjpeg/install-stamp
src/libs-install-stamp: src/expat/install-stamp
src/libs-install-stamp: src/exiv2/install-stamp
src/libs-install-stamp: src/poppler/install-stamp
src/libs-install-stamp: src/winiconv/install-stamp
	install -d dist/doc/
	$(rst2html) doc/COPYING.libs.txt > dist/doc/COPYING.libs.html
	touch $(@)

# Poppler

src/poppler/source-stamp:
	mkdir -p $(dir $@)
	tools/wget https://poppler.freedesktop.org/poppler-22.08.0.tar.xz b493328721402f25cb7523f9cdc2f7d7c59f45ad999bde75c63c90604db0f20b
	$(untar) src.tar/poppler-22.08.0.tar.xz -C $(dir $@)
	cd $(dir $@) && QUILT_PATCHES=../../patches/poppler quilt push -a
	rm -rf $(dir $@)/*.cache $(dir $@)/*~
	touch $(@)

src/poppler/Makefile: src/poppler/source-stamp
src/poppler/Makefile: src/fontconfig/install-stamp
src/poppler/Makefile: src/libjpeg/install-stamp
src/poppler/Makefile: src/openjpeg/install-stamp
	cd $(dir $@) && \
		cmake $(cmake_options) . \
		-DBUILD_CPP_TESTS=OFF \
		-DBUILD_GTK_TESTS=OFF \
		-DBUILD_MANUAL_TESTS=OFF \
		-DBUILD_QT5_TESTS=OFF \
		-DENABLE_BOOST=OFF \
		-DENABLE_CMS=none \
		-DENABLE_CPP=OFF \
		-DENABLE_GLIB=OFF \
		-DENABLE_GTK_DOC=OFF \
		-DENABLE_LIBCURL=OFF \
		-DENABLE_LIBOPENJPEG=openjpeg2 \
		-DENABLE_QT5=OFF \
		-DENABLE_QT6=OFF \
		-DENABLE_SPLASH=ON \
		-DENABLE_UNSTABLE_API_ABI_HEADERS=ON \
		-DENABLE_UTILS=OFF \
		-DFONT_CONFIGURATION=fontconfig \
		-DTESTDATADIR=/nonexistent \
		-DWITH_NSS3=OFF \
		-DWITH_PNG=OFF \
		-DWITH_TIFF=OFF
	find $(dir $@) -name build.make -print0 \
	| xargs -0 sed -i -e 's,\([ 	]\)\(/[^ 	]\+/\($(CC)\|$(CXX)\)\) ,\1$(CURDIR)/tools/enforce-relative-paths \2 ,'

include/dummy-mutex: misc/dummy-mutex.hh
	install -m 644 $(<) $(@)

src/poppler/build-stamp: src/poppler/Makefile include/dummy-mutex
	$(MAKE) -C $(dir $@)
	touch $(@)

src/poppler/install-stamp: src/poppler/build-stamp
	$(MAKE) -C $(dir $@) install
	$(call ship_dll,libpoppler)
	touch $(@)

# poppler-data

src/poppler-data/source-stamp:
	mkdir -p $(dir $@)
	tools/wget https://poppler.freedesktop.org/poppler-data-0.4.11.tar.gz 2cec05cd1bb03af98a8b06a1e22f6e6e1a65b1e2f3816cb3069bb0874825f08c
	$(untar) src.tar/poppler-data-0.4.11.tar.gz -C $(dir $@)
	touch $(@)

src/poppler-data/build-stamp: src/poppler-data/source-stamp
	$(MAKE) -C $(dir $@)
	touch $(@)

src/poppler-data/install-stamp: src/poppler-data/build-stamp
	$(MAKE) -C $(dir $@) install prefix=$(usr)
	install -d dist/share/
	cp -a share/poppler dist/share/
	install -d dist/doc/
	$(rst2html) doc/COPYING.poppler-data.txt > dist/doc/COPYING.poppler-data.html
	touch $(@)

# DjVuLibre

src/djvulibre/source-stamp:
	mkdir -p $(dir $@)
	tools/wget https://downloads.sourceforge.net/project/djvu/DjVuLibre/3.5.28/djvulibre-3.5.28.tar.gz fcd009ea7654fde5a83600eb80757bd3a76998e47d13c66b54c8db849f8f2edc
	$(untar) src.tar/djvulibre-3.5.28.tar.gz -C $(dir $@)
	sed -i -e 's/[A-Z]\+_EXPORT/DLL_EXPORT/' $(dir $@)/libdjvu/*.h
	sed -i -e 's/#if.*def.*AUTOCONF.*/#if 0/' $(dir $@)/libdjvu/DjVuMessage.cpp
	touch $(@)

src/djvulibre/config.status: src/djvulibre/source-stamp
	cd $(dir $@) && \
		./configure --host=$(host) --prefix=$(usr) \
		--without-jpeg \
		--disable-static

src/djvulibre/build-stamp: src/djvulibre/config.status
	$(MAKE) -C $(dir $@)/libdjvu
	$(MAKE) -C $(dir $@)/tools
	touch $(@)

src/djvulibre/install-stamp: src/djvulibre/build-stamp
	install -d dist/
	$(MAKE) -C $(dir $@)/libdjvu install
	$(MAKE) -C $(dir $@)/tools install
	set -e && \
	for tool in $(djvulibre_tools); do \
		install bin/$$tool.exe bin/$$tool; \
		install bin/$$tool.exe dist/; \
		$(STRIP) dist/$$tool.exe; \
	done
	$(call ship_dll,libdjvulibre)
	touch $(@)

# GraphicsMagick

src/graphicsmagick/source-stamp:
	mkdir -p $(dir $@)
	tools/wget https://downloads.sourceforge.net/project/graphicsmagick/graphicsmagick/1.3.38/GraphicsMagick-1.3.38.tar.xz d60cd9db59351d2b9cb19beb443170acaa28f073d13d258f67b3627635e32675
	$(untar) src.tar/GraphicsMagick-1.3.38.tar.xz -C $(dir $@)
	cd $(dir $@) && QUILT_PATCHES=../../patches/graphicsmagick quilt push -a
	cd $(dir $@) && autoreconf -vfi
	rm -rf $(dir $@)/*.cache $(dir $@)/magick/*~
	touch $(@)

src/graphicsmagick/config.status: src/graphicsmagick/source-stamp
	cd $(dir $@) && \
		./configure --host=$(host) --prefix=$(usr) \
			--disable-installed \
			--disable-openmp --without-threads \
			--enable-shared --disable-static \
			--with-quantum-depth=8 \
			--without-frozenpaths \
			--without-perl \
			--without-bzlib \
			--without-dps \
			--without-fpx \
			--without-jbig \
			--without-webp \
			--without-jpeg \
			--without-jp2 \
			--without-lcms2 \
			--without-lzma \
			--without-png \
			--without-tiff \
			--without-trio \
			--without-ttf \
			--without-umem \
			--without-wmf \
			--without-xml \
			--without-zlib \
			--without-x \
			--without-png \
			--without-gdi32

src/graphicsmagick/build-stamp: src/graphicsmagick/config.status
	$(MAKE) -C $(dir $@)
	touch $(@)

src/graphicsmagick/install-stamp: src/graphicsmagick/build-stamp
	install -d dist/
	$(MAKE) -C $(dir $@) install
	$(call ship_dll,libGraphicsMagick)
	rm dist/libGraphicsMagickWand*.dll
	install -d dist/share/GraphicsMagick
	install -m 644 share/GraphicsMagick-1.3.38/config/*.mgk dist/share/GraphicsMagick
	touch $(@)

# Expat

src/expat/source-stamp:
	mkdir -p $(dir $@)
	tools/wget https://github.com/libexpat/libexpat/releases/download/R_2_4_8/expat-2.4.8.tar.xz f79b8f904b749e3e0d20afeadecf8249c55b2e32d4ebb089ae378df479dcaf25
	$(untar) src.tar/expat-2.4.8.tar.xz -C $(dir $@)
	touch $(@)

src/expat/config.status: src/expat/source-stamp
	cd $(dir $@) && \
		./configure --host=$(host) --prefix=$(usr) \
		--without-docbook \
		--disable-static

src/expat/build-stamp: src/expat/config.status
	$(MAKE) -C $(dir $@)
	touch $(@)

src/expat/install-stamp: src/expat/build-stamp
	install -d dist/
	$(MAKE) -C $(dir $@) install
	$(call ship_dll,libexpat)
	touch $(@)

# Exiv2

src/exiv2/source-stamp:
	mkdir -p $(dir $@)
	tools/wget https://github.com/Exiv2/exiv2/releases/download/v0.27.5/exiv2-0.27.5-Source.tar.gz -n exiv2-0.27.5.tar.gz 35a58618ab236a901ca4928b0ad8b31007ebdc0386d904409d825024e45ea6e2
	$(untar) src.tar/exiv2-0.27.5.tar.gz -C $(dir $@)
	cd $(dir $@) && QUILT_PATCHES=../../patches/exiv2 quilt push -a
	touch $(@)

src/exiv2/Makefile: src/exiv2/source-stamp

=== PKGBUILD ===
# Maintainer: Oleg Tolmatcev <oleg.tolmatcev@gmail.com>

_realname=pdf2djvu
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=0.9.19
pkgrel=15
pkgdesc="Creates DjVu files from PDF files (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64')
url="https://jwilk.net/software/pdf2djvu"
license=('spdx:GPL-2.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-djvulibre"
         "${MINGW_PACKAGE_PREFIX}-exiv2"
         "${MINGW_PACKAGE_PREFIX}-gettext-runtime"
         "${MINGW_PACKAGE_PREFIX}-graphicsmagick"
         "${MINGW_PACKAGE_PREFIX}-libiconv"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-poppler")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-autotools"
             "${MINGW_PACKAGE_PREFIX}-gettext-tools"
             "autoconf-archive")
checkdepends=("${MINGW_PACKAGE_PREFIX}-python2-nose")
source=(https://github.com/jwilk/pdf2djvu/releases/download/${pkgver}/pdf2djvu-${pkgver}.tar.xz{,.asc}
        "001-cxx17-for-poppler.patch")
sha256sums=('eb45a480131594079f7fe84df30e4a5d0686f7a8049dc7084eebe22acc37aa9a'
            'SKIP'
            '4c50966b0fc05d78f6ec78b20df587fb5e1861f3ff326ee66c8baf10ec3cb39f')
validpgpkeys=('CDB5A1243ACDB63009AD07212D4EB3A6015475F5') # Jakub Wilk <jwilk@jwilk.net>
noextract=(pdf2djvu-${pkgver}.tar.xz)

prepare() {
  [[ -d ${_realname}-${pkgver} ]] && rm -rf ${_realname}-${pkgver}
  tar -xf pdf2djvu-${pkgver}.tar.xz || true

  cp "${srcdir}"/${_realname}-${pkgver}/tests/test-antialias-off.tex \
     "${srcdir}"/${_realname}-${pkgver}/tests/test-antialias-on.tex
  cd "${srcdir}"/${_realname}-${pkgver}

  patch -p1 -i "${srcdir}/001-cxx17-for-poppler.patch"

  autoreconf -fvi
}

build() {
  [[ -d "${srcdir}"/build-${MSYSTEM} ]] && rm -rf "${srcdir}"/build-${MSYSTEM}
  cp -rf ${_realname}-${pkgver} build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  CXXFLAGS+=" -Wno-ignored-attributes -std=c++20 -DWIN32" \
  ./configure \
      --prefix=${MINGW_PREFIX} \
      --with-libiconv-prefix=${MINGW_PREFIX}

  make
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  make DESTDIR="${pkgdir}" install

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/doc/COPYING "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/COPYING
}
